const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const audit_events = sequelize.define(
    'audit_events',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

event_type: {
        type: DataTypes.TEXT,
      
      

      },

event_summary: {
        type: DataTypes.TEXT,
      
      

      },

event_at: {
        type: DataTypes.DATE,
      
      

      },

source_ip: {
        type: DataTypes.TEXT,
      
      

      },

user_agent: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  audit_events.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.audit_events.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.audit_events.belongsTo(db.users, {
      as: 'actor_user',
      foreignKey: {
        name: 'actor_userId',
      },
      constraints: false,
    });

    db.audit_events.belongsTo(db.contract_folders, {
      as: 'contract_folder',
      foreignKey: {
        name: 'contract_folderId',
      },
      constraints: false,
    });

    db.audit_events.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.audit_events.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.audit_events.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return audit_events;
};


